/*
 *  ESSilverlightView.h
 *  Flash'In'App
 *
 *  Copyright 2009 Eltima Software. All rights reserved.
 *
 *	Flash'In'App is not free since version 2.0.
 *	If you plan to integrate it in your project, please, purchase a license at http://mac.eltima.com/flashinapp.html
 *	Questions? Please, contact Eltima at sales@eltima.com or visit http://mac.eltima.com for more info
 *  Full usage and integration guide can be found here: http://wiki.eltima.com/user-guides/flash-in-app-macos.html
 */

#import <Cocoa/Cocoa.h>
#import "ESScriptingPluginView.h"

@interface ESSilverLightView : ESScriptingPluginView
{
  NSString *initParams;
  NSString *minRuntimeVersion;

  NSArray *embedKeys;
  NSArray *embedValues;
}

/*
 * set/get initial parameters(initParams) for the movie
 */
- (void) setInitParams:(NSString *)aValue;
- (NSString *) initParams;

/*
 * set/get minimum version of runtime (minRuntimeVersion) for the movie
 */
- (void) setMinRuntimeVersion:(NSString *)aValue;
- (NSString *) minRuntimeVersion;

/*
 * set all the rest of parameters provided by Microsoft using this method
 * setAttributeKeys:andValues: method has to be called before loading any movie
 * NOTE: should you be changing movie parameters in runtime, you will need to reload the movie (loadMovie:atURL:withBaseURL:) 
 */
- (void)setAttributeKeys:(NSArray *)keys andValues:(NSArray *)values;
- (NSArray *) attributeKeys;
- (NSArray *) attributeValues;

@end

@interface NSObject (ESSilverLightViewDelegate)

/*
 * This method is called when the message from Silverlight is received
 * 
 * aSilverlightView - the Silverlight view that sent the message
 * aName - the name of the function that was called
 * anArguments - the arguments, the function was called with 
 */
- (id) silverlightView:(ESSilverLightView *)aSilverlightView callFunction:(NSString *)aName withArguments:(NSArray *)anArguments;

@end
